use ev3dev_lang_rust::Ev3Button;
use ev3dev_lang_rust::Ev3Result;
use paste::paste;

macro_rules! button_impl {
    ($($name: ident),*) => {
        paste! {

            pub struct SmartEv3Buttons {
                buttons: Ev3Button,
                $(
                    [<last_ $name>]: bool,
                )*
            }

            impl SmartEv3Buttons {
                pub fn new() -> Ev3Result<Self> {
                    let buttons = Ev3Button::new()?;
                    buttons.process();
                    $(
                        let [<last_ $name>] = buttons.[<is_ $name>]();
                    )*
                        Ok(Self {
                            buttons,
                            $(
                                [<last_ $name>],
                            )*
                        })
                }

                pub fn process(&mut self) {
                    $(
                        self.[<last_ $name>] = self.buttons.[<is_ $name>]();
                    )*
                    self.buttons.process();
                }

                $(
                    #[allow(dead_code)]
                    pub fn [<is_ $name>](&self) -> bool {
                        self.buttons.[<is_ $name>]()
                    }

                    #[allow(dead_code)]
                    pub fn [<is_ $name _pressed>](&self) -> bool {
                        self.buttons.[<is_ $name>]() && !self.[<last_ $name>]
                    }

                    #[allow(dead_code)]
                    pub fn [<is_ $name _released>](&self) -> bool {
                        !self.buttons.[<is_ $name>]() && self.[<last_ $name>]
                    }
                )*
            }
        }
    };
}

button_impl!(up, down, left, right, enter, backspace);
